// FileHelloWorld.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>

// program vytvori soubor hello.txt v pracovnim adresari a zapise
// do nej Hello World!
int main()
{
	FILE * f; // deklarujeme si ukazatel na strukturu FILE, do ktere
	          // se ulozi hodnota pri otevreni a tento ukazatel dale
	          // pouzivame pri zapisu a cteni ze/do souboru, tj. predavame
	          // ho jako parametr funkcim pracujicim se souborem, aby
	          // vedely, ktery ze soubor to je, ze ktereho chceme cist
	          // nebo do ktereho chceme zapisovat

	f = fopen("hello.txt", "w");
		// fopen otevre soubor, cestu k nemu zadavame v prvnim parametru.
		// pokud nezadame celou cestu (vcetne pismena disku), bere se
	  // cesta relativne k aktualnimu adresari (coz byva adresar, ve kterem
		// je nami spousteny soubor .exe
		// druhy parametr rika, v jakem modu chceme soubor otevrit.
		// "w" znamena, ze otevirame pro zapis, soubor se ma vytvorit, pokud
		// neexistuje a nebo prepsat, pokud existuje
		// funkce vraci ukazatel na stukturu FILE, ktery si ulozime do
		// predem deklarovane promenne tohoto typu a budeme ho nadale
		// davat funkcim, po kterych budeme chtit, aby s timto souborem
		// pracovaly

	if (f == NULL)
	{
		// jestlize se nepodari soubor otevrit, vrati fopen() NULL, a je treba
		// to otestovat, protoze funkcim pro cteni a zapis musime dat platny
		// ukazatel na FILE. Pokud se nepodarilo soubor otevrit, vypiseme
		// hlasku a koncime
		puts("Nepodarilo se otevrit soubor.");
		return -1;
	}

	// nyni vime, ze mame soubor korektne otevren a muzeme zapisovat
	fputs("Hello World!", f); // fputs je treba dat f, aby vedela, ze
	                          // chceme zapisovat do "hello.txt"

	// a oznamime uzivateli, ze je zapsano
	puts("Hello World! zapsano do souboru");

	// a nakonec je treba soubor zavrit a tim rici, ze uz jsme praci
	// s nim ukoncili
	if (fclose(f) == EOF)
		puts("Nepodarilo se soubor uzavrit, nemusi v nem byt vsechno.");
		// muzeme zkontrolovat, zda se soubor podarilo zavrit, ale pokud
		// se to nepovede, tak s tim uz nic moc nemuzeme udelat, jedine
		// muzeme upozornit uzivatele, ze v souboru nemusi byt zapsana
		// vsechna data

	getch();

	return 0;
}

